<?php

namespace Teknisa\CADEST\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;


class Ger15300OperadorController extends \Teknisa\CADEST\Controllers\TeknisaCrud {

    protected $dataSourceName = 'filgrupfili_operador';
    
     public function __construct($crudService, ParameterBag $parameterBag, $connection, $environment) {
        $this->environment = $environment;
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->con = $connection;
    }
	
    
    public function saveOperador(DTO\Request\DataSet $request, DTO\Response $response) {
    
        try{
            $NRORG = $this->environment->getNRORG();
		    $data = $request->getDataSet()->getRows();
		    $row = $request->getDataSet()->getRows()[0]; 
		
		    $query = 'SELECT CDOPERADOR FROM GRUPFILIOPER WHERE CDGRUPFILI = :CDGRUPFILI AND CDOPERADOR = :CDOPERADOR GROUP BY CDOPERADOR';
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDGRUPFILI" => $data[0]['CDGRUPFILI'],
                "CDOPERADOR" => $data[0]['CDOPERADOR']
            ));
            $result = $stmt->fetchAll();

            if(count($result) > 0 && $row['__is_new']) {
                throw new \Exception('Esse operador já foi cadastrado para essse agrupamento');    
            }
            
            $query = "SELECT AUTGRUPOP.IDAUTGRUPOP FROM AUTGRUPOP, OPERGRUPOP WHERE AUTGRUPOP.IDAUTGRUPOP = 'APAF' AND AUTGRUPOP.CDGRUPOPER = OPERGRUPOP.CDGRUPOPER AND OPERGRUPOP.CDOPERADOR = :CDOPERADOR";
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDOPERADOR" => $data[0]['CDOPERADOR']
            ));
            $result = $stmt->fetchAll();

            if(count($result) === 0 && $row['__is_new']) {
                throw new \Exception('Operador sem permissão para aprovação de alteração em AFs.');    
            }
            
            $query = 'INSERT INTO GRUPFILIOPER (CDOPERADOR, CDGRUPFILI, NRORG) VALUES (:CDOPERADOR, :CDGRUPFILI, :NRORG)';
            $stmt = $this->con->prepare($query);
            $stmt->execute(array(
                "CDOPERADOR" => $data[0]['CDOPERADOR'],
                "CDGRUPFILI" => $data[0]['CDGRUPFILI'],
                "NRORG" => $NRORG
            ));
            
        } catch (\Exception $e) {
                $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
        
        
        
	}
}