/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOCOBR                                                 */
/* Tabela : TIPOCOBR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOCOBR
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOCOBR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPCB := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPCOB,0)   <> NVL(:NEW.CDTIPCOB,0))   OR
         (NVL(:OLD.NMTIPOCOBR,0) <> NVL(:NEW.NMTIPOCOBR,0)) THEN
         :NEW.DTULTATUTPCB := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOCOBR', '', 'CDTIPCOB='||:OLD.CDTIPCOB||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOCOBR MODIFY DTULTATUTPCB DEFAULT SYSDATE
/
