DROP FUNCTION VERIFICA_APURACAO_OL
/

DROP TYPE VERIFICA_APURACAO_OL_TABLE
/

DROP TYPE VERIFICA_APURACAO_OL_TYPE
/

CREATE TYPE VERIFICA_APURACAO_OL_TYPE AS OBJECT
  (CDFILIALOL     VARCHAR2(4),
   NMFILIALOL     VARCHAR2(30),
   DTINICIAL      DATE,
   DTFINAL        DATE,
   CDOPERADOR     VARCHAR2(12),
   NMOPERADOR     VARCHAR2(40),
   CDARVPROD      VARCHAR2(20),
   NMPRODUTO      VARCHAR2(50),
   CDMARCA        VARCHAR2(5),
   NMMARCA        VARCHAR2(20),
   IDSITUCOLETA   CHAR(1),
   IDSITUAND      CHAR(1),
   QTPROGENTAF    CHAR(1),
   REFORFIL       CHAR(1),
   IDAPRMARPRO    CHAR(1),
   CDQUALIF       CHAR(1),
   QFOPRODFORN    CHAR(1),
   PRODCOMP       CHAR(1),
   IDTIPOFORN     CHAR(1),
   IDSITUCADA     CHAR(1),
   IDMARCAPADRAO  CHAR(1),
   PRODCMPFILI    CHAR(1),
   STERRO         CHAR(1),
   QTPROGENTAF1   FLOAT,
   IDSEMRELAC     CHAR(1)
  )
/

CREATE TYPE VERIFICA_APURACAO_OL_TABLE AS TABLE OF VERIFICA_APURACAO_OL_TYPE
/

CREATE OR REPLACE FUNCTION VERIFICA_APURACAO_OL
                          (P_CDFILIOPELOG    IN ITEMAUTF.CDFILDEST%TYPE,
                           P_DTINICIAL       IN DATE,
                           P_DTFINAL         IN DATE,
                           P_CDOPERADOR      IN VARCHAR2,
                           P_NRLOGCORTEOL    IN LOGITEMCORTEOL.NRLOGCORTEOL%TYPE)
                          RETURN VERIFICA_APURACAO_OL_TABLE PIPELINED IS
   OUT_RECORD VERIFICA_APURACAO_OL_TYPE := VERIFICA_APURACAO_OL_TYPE (NULL, NULL, NULL, NULL, NULL, NULL,
                                                                      NULL, NULL, NULL, NULL, NULL, NULL,
                                                                      NULL, NULL, NULL, NULL, NULL, NULL,
                                                                      NULL, NULL, NULL, 0   , NULL, NULL,
                                                                      NULL);
   V_IDSITUCOLETA     CHAR(1);
   V_QTPROGENTAF      FLOAT;
   V_REFORFIL         FLOAT;
   V_IDAPRMARPRO      FLOAT;
   V_CDQUALIF         FLOAT;
   V_QFOPRODFORN      FLOAT;
   V_PRODCOMP         FLOAT;
   V_IDTIPOFORN       CHAR(1);
   V_IDSITUCADA       CHAR(1);
   V_IDMARCAPADRAO    FLOAT;

   V_CDFORNECED       VARCHAR2(21);

   V_E_IDSITUCOLETA   CHAR(1);
   V_E_IDSITUAND      CHAR(1);
   V_E_QTPROGENTAF    CHAR(1);
   V_E_REFORFIL       CHAR(1);
   V_E_IDAPRMARPRO    CHAR(1);
   V_E_CDQUALIF       CHAR(1);
   V_E_QFOPRODFORN    CHAR(1);
   V_E_PRODCOMP       CHAR(1);
   V_E_IDTIPOFORN     CHAR(1);
   V_E_IDSITUCADA     CHAR(1);
   V_E_IDMARCAPADRAO  CHAR(1);
   V_E_PRODCMPFILI    CHAR(1);
   V_STERRO           CHAR(1) := 'N';
   V_CTPRODCMP        FLOAT;
   V_IDSEMRELAC       CHAR(1) := 'N';

BEGIN
   FOR C_DADOS_CAB IN (SELECT LOGITEMCORTEOL.CDFILIOPELOG CDFILIALOL, FILIAL.NMFILIAL NMFILIALOL, P_DTINICIAL DTINICIAL, P_DTFINAL DTFINAL,
                              MAX(DTPROGENTAF) DTINIVALITM, MIN(DTPROGENTAF) DTFINVALITM , OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR,
                              PRODUTO.CDARVPROD, PRODUTO.NMPRODUTO, MARCA.CDMARCA, MARCA.NMMARCA, FILIAL.CDREGIAO, LOGITEMCORTEOL.CDPRODUTO,
                              NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL) CDFILCENTCMP, LOGITEMCORTEOL.CDPRODARVOL,
                              SUM(LOGITEMCORTEOL.QTPROGENTAF) QTPROGENTAF
                         FROM LOGITEMCORTEOL, FILIAL, PRODUTO, MARCA, OPERADOR
                        WHERE LOGITEMCORTEOL.NRLOGCORTEOL = P_NRLOGCORTEOL
                          AND LOGITEMCORTEOL.CDFILIOPELOG = FILIAL.CDFILIAL
                          AND LOGITEMCORTEOL.CDFILIOPELOG = P_CDFILIOPELOG
                          AND LOGITEMCORTEOL.CDFILIOPELOG <> LOGITEMCORTEOL.CDFILDEST
                          AND LOGITEMCORTEOL.CDPRODUTO    = PRODUTO.CDPRODUTO
                          AND LOGITEMCORTEOL.CDMARCA      = MARCA.CDMARCA
                          AND OPERADOR.CDOPERADOR         = P_CDOPERADOR
                          AND LOGITEMCORTEOL.QTPROGENTAF  > 0
                        GROUP BY LOGITEMCORTEOL.CDFILIOPELOG, FILIAL.NMFILIAL, OPERADOR.CDOPERADOR, OPERADOR.NMOPERADOR,
                              PRODUTO.CDARVPROD, PRODUTO.NMPRODUTO, MARCA.CDMARCA, MARCA.NMMARCA, FILIAL.CDREGIAO,
                              LOGITEMCORTEOL.CDPRODUTO, NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL), LOGITEMCORTEOL.CDPRODARVOL)
   LOOP
      V_IDSITUCOLETA     := '';
      V_QTPROGENTAF      := 0;
      V_REFORFIL         := 0;
      V_E_IDSITUCOLETA   := 'N';
      V_E_QTPROGENTAF    := 'N';
      V_E_REFORFIL       := 'N';
      V_E_IDAPRMARPRO    := 'N';
      V_E_CDQUALIF       := 'N';
      V_E_QFOPRODFORN    := 'N';
      V_E_PRODCOMP       := 'N';
      V_E_IDSITUAND      := 'N';
      V_E_IDTIPOFORN     := 'N';
      V_E_IDSITUCADA     := 'N';
      V_E_IDMARCAPADRAO  := 'N';
      V_E_PRODCMPFILI    := 'N';
      V_IDSEMRELAC       := 'N';
      SELECT MAX(NVL(COLETAPR.IDSITUCOLETA, 'C'))
        INTO V_IDSITUCOLETA
        FROM COLETAPR, ITEMCOLE
       WHERE ITEMCOLE.CDFILIAL     = C_DADOS_CAB.CDFILCENTCMP
         AND ITEMCOLE.CDREGIAO     = C_DADOS_CAB.CDREGIAO
         AND ITEMCOLE.CDPRODUTO    = C_DADOS_CAB.CDPRODUTO
         AND ITEMCOLE.CDMARCA      = C_DADOS_CAB.CDMARCA
         AND ITEMCOLE.VRPRECUNIITM <> 0
         AND ITEMCOLE.DTINIVALITM BETWEEN CASE
                                             WHEN ITEMCOLE.DTINIVALITM < C_DADOS_CAB.DTINIVALITM
                                             THEN ITEMCOLE.DTINIVALITM
                                             ELSE C_DADOS_CAB.DTINIVALITM
                                          END AND C_DADOS_CAB.DTFINVALITM
         AND ITEMCOLE.DTFINVALITM BETWEEN C_DADOS_CAB.DTINIVALITM
                                      AND CASE
                                         WHEN ITEMCOLE.DTFINVALITM > C_DADOS_CAB.DTFINVALITM
                                         THEN ITEMCOLE.DTFINVALITM
                                         ELSE C_DADOS_CAB.DTFINVALITM
                                      END
         AND COLETAPR.CDFILIAL     = ITEMCOLE.CDFILIAL
         AND COLETAPR.CDOPERADOR   = P_CDOPERADOR
         AND COLETAPR.NRCOLEPRECO  = ITEMCOLE.NRCOLEPRECO;
      IF V_IDSITUCOLETA IS NULL THEN
         /*ITEM NO COTADO*/
         V_E_IDSITUCOLETA := 'S';
         V_STERRO         := 'S';
      ELSE
         IF V_IDSITUCOLETA = 'C' THEN
            V_E_IDSITUAND  := 'N';
            SELECT NVL(SUM(ITEMAUTF.QTPROGENTAF-NVL(QTEFETENTRAF, 0)), 0)
              INTO V_QTPROGENTAF
              FROM ITEMAUTF, AUTOFORNE
             WHERE ITEMAUTF.CDFILDEST    = AUTOFORNE.CDFILDEST
               AND ITEMAUTF.CDFILLANC    = AUTOFORNE.CDFILLANC
               AND ITEMAUTF.NRAUTOFORN   = AUTOFORNE.NRAUTOFORN
               AND ITEMAUTF.CDFILDEST    = C_DADOS_CAB.CDFILIALOL
               AND ITEMAUTF.CDPRODUTO    = C_DADOS_CAB.CDPRODARVOL
               AND ITEMAUTF.DTPROGENTAF >= TRUNC(SYSDATE)
               AND AUTOFORNE.CDOPERADOR  = P_CDOPERADOR
               AND CASE AUTOFORNE.IDTIPOLANCAF
                      WHEN 'M'
                      THEN ITEMAUTF.DTPROGENTAF
                      ELSE NVL(ITEMAUTF.DTENTRITMSOL, ITEMAUTF.DTPROGENTAF)
                   END BETWEEN C_DADOS_CAB.DTINICIAL AND C_DADOS_CAB.DTFINAL
               AND ((INSTR(P_CDOPERADOR, AUTOFORNE.CDOPERADOR) > 0) OR (P_CDOPERADOR = 'T'))
               AND NVL(ITEMAUTF.IDBAIXITMAF, '1')   = '1'
               AND NVL(AUTOFORNE.IDBAIXAAF, '1')  NOT IN ('2', '3', '4', '5');
            IF V_QTPROGENTAF >= C_DADOS_CAB.QTPROGENTAF THEN
               /*J EXISTE AF DO OL PARA O PERODO FILTRADO*/
               V_E_QTPROGENTAF := 'S';
               V_STERRO        := 'S';
            END IF;
            IF V_E_QTPROGENTAF <> 'S' THEN
               SELECT COUNT(1)
                 INTO V_REFORFIL
                 FROM (SELECT COLETAPR.IDSITUCOLETA
                         FROM COLETAPR, ITEMCOLE, REFORFIL
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND REFORFIL.CDFILIAL      = C_DADOS_CAB.CDFILIALOL
                          AND REFORFIL.CDFORNECED    = ITEMCOLE.CDFORNECED
                          AND REFORFIL.CDPERIENTR    IS NOT NULL
                       UNION ALL
                       SELECT COLETAPR.IDSITUCOLETA
                         FROM COLETAPR, ITEMCOLE
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND NOT EXISTS (SELECT REFORFIL.CDFILIAL
                                            FROM REFORFIL
                                           WHERE REFORFIL.CDFILIAL   = C_DADOS_CAB.CDFILIALOL
                                             AND REFORFIL.CDFORNECED = ITEMCOLE.CDFORNECED));
               /*FORNECEDOR NO ATENDE A FILIAL*/
               IF V_REFORFIL = 0 THEN
                  V_E_REFORFIL := 'S';
                  V_STERRO     := 'S';
               END IF;
               SELECT COUNT(CDFILIAL)
                 INTO V_IDAPRMARPRO
                 FROM (SELECT PARASUPRI.CDFILIAL
                         FROM COLETAPR, ITEMCOLE, QFOMARPROD, PARASUPRI, PRODUTO
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND (PARASUPRI.CDFILIAL    = ITEMCOLE.CDFILIAL)
                          AND (QFOMARPROD.CDPRODUTO  = ITEMCOLE.CDPRODUTO)
                          AND (QFOMARPROD.CDMARCA    = ITEMCOLE.CDMARCA)
                          AND ((QFOMARPROD.IDAPRMARPRO = 'N' AND QFOMARPROD.IDAUTMARPRO = 'S')
                          OR  ((QFOMARPROD.IDAPRMARPRO = 'S') AND ((PARASUPRI.IDULTIDTVALQ = 'M'
                          AND COLETAPR.DTCOLEPREC <= LAST_DAY(QFOMARPROD.DTVALAPROVA))
                          OR  (PARASUPRI.IDULTIDTVALQ = 'D'
                          AND COLETAPR.DTCOLEPREC <= QFOMARPROD.DTVALAPROVA)) ) )
                        UNION ALL
                       SELECT PARASUPRI.CDFILIAL
                         FROM COLETAPR, ITEMCOLE, PARASUPRI
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND (PARASUPRI.CDFILIAL    = C_DADOS_CAB.CDFILCENTCMP
                          AND PARASUPRI.IDMARSEMQUA  <> 'S'
                          AND NOT EXISTS (SELECT QFOMARPROD.CDMARCA
                                            FROM QFOMARPROD
                                           WHERE (QFOMARPROD.CDPRODUTO = ITEMCOLE.CDPRODUTO)
                                             AND (QFOMARPROD.CDMARCA   = ITEMCOLE.CDMARCA))));
               /*QUALIFICAO DE MARCA*/
               IF V_IDAPRMARPRO = 0 THEN
                  V_E_IDAPRMARPRO := 'S';
                  V_STERRO        := 'S';
               END IF;

               SELECT COUNT(CDFILIAL)
                 INTO V_CDQUALIF
                 FROM (SELECT ITEMCOLE.CDFILIAL
                         FROM QUALIFICACAO, PARASUPRI, FORNECEDOR, COLETAPR, ITEMCOLE
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED
                          AND PARASUPRI.CDFILIAL     = C_DADOS_CAB.CDFILCENTCMP
                          AND FORNECEDOR.CDQUALIF    = QUALIFICACAO.CDQUALIF
                          AND (QUALIFICACAO.IDPERCOTCMP <> '2' AND (FORNECEDOR.IDFORNAUTO = 'S'
                          OR  ((PARASUPRI.IDULTIDTVALQ = 'D'   AND COLETAPR.DTCOLEPREC < FORNECEDOR.DTVALQUALIF)
                          OR  (PARASUPRI.IDULTIDTVALQ = 'M'    AND COLETAPR.DTCOLEPREC < LAST_DAY(FORNECEDOR.DTVALQUALIF)))))
                        UNION ALL
                       SELECT ITEMCOLE.CDFILIAL
                         FROM PARASUPRI, FORNECEDOR, COLETAPR, ITEMCOLE
                        WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                          AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                          AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                          AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                          AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                          AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                          AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                          AND ITEMCOLE.VRPRECUNIITM  <> 0
                          AND COLETAPR.IDSITUCOLETA  = 'C'
                          AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                          AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                          AND FORNECEDOR.CDFORNECED  = ITEMCOLE.CDFORNECED
                          AND PARASUPRI.CDFILIAL     = ITEMCOLE.CDFILIAL
                          AND FORNECEDOR.CDQUALIF    IS NULL);
               /*QUALIFICAO DE FORNECEDOR*/
               IF V_CDQUALIF = 0 THEN
                  V_E_CDQUALIF := 'S';
                  V_STERRO     := 'S';
               END IF;

               SELECT COUNT(ITEMCOLE.CDFILIAL)
                 INTO V_QFOPRODFORN
                 FROM COLETAPR, ITEMCOLE
                WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                  AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                  AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                  AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                  AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                  AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                  AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                  AND ITEMCOLE.VRPRECUNIITM  <> 0
                  AND COLETAPR.IDSITUCOLETA  = 'C'
                  AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                  AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                  AND NOT EXISTS (SELECT QFOPRODFORN.CDPRODUTO
                                    FROM QFOPRODFORN, PARASUPRI
                                   WHERE PARASUPRI.CDFILIAL = ITEMCOLE.CDFILIAL
                                     AND (QFOPRODFORN.CDPRODUTO  = ITEMCOLE.CDPRODUTO)
                                     AND (QFOPRODFORN.CDFORNECED = ITEMCOLE.CDFORNECED)
                                     AND ((QFOPRODFORN.IDFORNAPROV = 'N'  AND QFOPRODFORN.IDFORNAUTOR = 'N')
                                     OR  ((QFOPRODFORN.IDFORNAPROV = 'S') AND ((PARASUPRI.IDULTIDTVALQ = 'M'
                                     AND COLETAPR.DTCOLEPREC > LAST_DAY(QFOPRODFORN.DTVALPRFORN)) OR (PARASUPRI.IDULTIDTVALQ = 'D'
                                     AND COLETAPR.DTCOLEPREC > QFOPRODFORN.DTVALPRFORN)) ) ));
               /*QUALIFICAO DE PRODUTO POR FORNECEDOR*/
               IF V_QFOPRODFORN = 0 THEN
                  V_E_QFOPRODFORN := 'S';
                  V_STERRO        := 'S';
               END IF;
               SELECT COUNT(ITEMCOLE.CDFILIAL)
                 INTO V_PRODCOMP
                 FROM COLETAPR, ITEMCOLE
                WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                  AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                  AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                  AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                  AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                  AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                  AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                  AND ITEMCOLE.VRPRECUNIITM  <> 0
                  AND COLETAPR.IDSITUCOLETA  = 'C'
                  AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                  AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                  AND EXISTS (SELECT
                                1
                              FROM
                                PRODCOMP,
                                PRODUTO
                              WHERE
                                (PRODUTO.CDPRODUTO = PRODCOMP.CDPRODUTO) AND
                                (CDOPERADOR = P_CDOPERADOR)  AND
                                (C_DADOS_CAB.CDARVPROD LIKE PRODUTO.CDARVPROD || '%'));
               /*PRODUTO POR COMPRADOR*/
               IF V_PRODCOMP = 0 THEN
                  V_E_PRODCOMP := 'S';
                  V_STERRO     := 'S';
               END IF;
               FOR C_COTACAO IN (SELECT ITEMCOLE.CDFORNECED
                                   FROM COLETAPR, ITEMCOLE
                                  WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                                    AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                                    AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                                    AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                                    AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                                    AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                                    AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                                    AND ITEMCOLE.VRPRECUNIITM  <> 0
                                    AND COLETAPR.IDSITUCOLETA  = 'C'
                                    AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                                    AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO)
               LOOP
                  /*FORNECEDOR SITUAO INATIVO*/
                  SELECT FORNECEDOR.IDSITUCADA
                    INTO V_IDSITUCADA
                    FROM FORNECEDOR
                   WHERE FORNECEDOR.CDFORNECED = C_COTACAO.CDFORNECED;
                  IF V_IDSITUCADA <> 'A' THEN
                     V_E_IDSITUCADA := 'S';
                     V_STERRO       := 'S';
                  END IF;

                  /*FORNECEDOR ALTERNATIVO*/
                  SELECT FORNECEDOR.IDTIPOFORN
                    INTO V_IDTIPOFORN
                    FROM FORNECEDOR
                   WHERE FORNECEDOR.CDFORNECED = C_COTACAO.CDFORNECED;
                  IF V_IDTIPOFORN <> 'N' THEN
                     V_E_IDTIPOFORN := 'S';
                     V_STERRO       := 'S';
                  END IF;
                  IF ((V_E_IDSITUCADA = 'S') AND (V_E_IDTIPOFORN = 'S')) THEN
                     EXIT;
                  END IF;
               END LOOP;

               SELECT COUNT(ITEMCOLE.CDFILIAL)
                 INTO V_IDMARCAPADRAO
                 FROM COLETAPR, ITEMCOLE, PARASUPRI
                WHERE ITEMCOLE.CDFILIAL      = C_DADOS_CAB.CDFILCENTCMP
                  AND ITEMCOLE.CDREGIAO      = C_DADOS_CAB.CDREGIAO
                  AND ITEMCOLE.CDPRODUTO     = C_DADOS_CAB.CDPRODUTO
                  AND ITEMCOLE.CDMARCA       = C_DADOS_CAB.CDMARCA
                  AND C_DADOS_CAB.DTINIVALITM  >= ITEMCOLE.DTINIVALITM
                  AND C_DADOS_CAB.DTFINVALITM  <= ITEMCOLE.DTFINVALITM
                  AND COLETAPR.CDOPERADOR    = P_CDOPERADOR
                  AND ITEMCOLE.VRPRECUNIITM  <> 0
                  AND COLETAPR.IDSITUCOLETA  = 'C'
                  AND COLETAPR.CDFILIAL      = ITEMCOLE.CDFILIAL
                  AND COLETAPR.NRCOLEPRECO   = ITEMCOLE.NRCOLEPRECO
                  AND PARASUPRI.CDFILIAL     = C_DADOS_CAB.CDFILCENTCMP
                  AND PARASUPRI.CDMARCA      = C_DADOS_CAB.CDMARCA;
               /*MARCA PADRO*/
               IF V_IDMARCAPADRAO = 0 THEN
                  V_E_IDMARCAPADRAO := 'S';
                  V_STERRO          := 'S';
               END IF;

            END IF;
         ELSE
            /*COTAO EM ANDAMENTO*/
            V_E_IDSITUAND  := 'S';
            V_STERRO       := 'S';
         END IF;

         SELECT COUNT(*)
           INTO V_CTPRODCMP
           FROM PRODCMPFILI,
                PRODUTO,
                PRODUTO P
          WHERE P.CDPRODUTO = C_DADOS_CAB.CDPRODUTO
            AND PRODCMPFILI.CDPRODUTO = PRODUTO.CDPRODUTO
            AND PRODCMPFILI.CDFILIAL = C_DADOS_CAB.CDFILIALOL
            --AND PRODCMPFILI.CDFILIOPELOG <> P_FILIPROC
            AND P.CDARVPROD LIKE PRODUTO.CDARVPROD||'%'
            AND PRODUTO.CDARVPROD > (SELECT DECODE(MAX(PR.CDARVPROD), NULL, '0', MAX(PR.CDARVPROD))
                                       FROM PRODNCMP, PRODUTO PR
                                      WHERE PRODNCMP.CDPRODUTO = PR.CDPRODUTO
                                        AND P.CDARVPROD LIKE PR.CDARVPROD||'%'
                                        AND PRODNCMP.CDFILIAL = C_DADOS_CAB.CDPRODUTO);
         IF V_CTPRODCMP = 0 THEN
            V_E_PRODCMPFILI := 'N';
         ELSE
            /*PRODUTO NO COMPRADO NA FILIAL*/
            V_E_PRODCMPFILI := 'S';
            V_STERRO        := 'S';
         END IF;

         /*PRODUTO SEM RELACIONAMENTO*/
         IF C_DADOS_CAB.CDPRODARVOL = C_DADOS_CAB.CDPRODUTO THEN
            V_IDSEMRELAC := 'S';
            V_STERRO     := 'S';
         END IF;
      END IF;
      OUT_RECORD.CDFILIALOL    := C_DADOS_CAB.CDFILIALOL;
      OUT_RECORD.NMFILIALOL    := C_DADOS_CAB.NMFILIALOL;
      OUT_RECORD.DTINICIAL     := C_DADOS_CAB.DTINICIAL;
      OUT_RECORD.DTFINAL       := C_DADOS_CAB.DTFINAL;
      OUT_RECORD.CDOPERADOR    := C_DADOS_CAB.CDOPERADOR;
      OUT_RECORD.NMOPERADOR    := C_DADOS_CAB.NMOPERADOR;
      OUT_RECORD.CDARVPROD     := C_DADOS_CAB.CDARVPROD;
      OUT_RECORD.NMPRODUTO     := C_DADOS_CAB.NMPRODUTO;
      OUT_RECORD.CDMARCA       := C_DADOS_CAB.CDMARCA;
      OUT_RECORD.NMMARCA       := C_DADOS_CAB.NMMARCA;
      OUT_RECORD.QTPROGENTAF1  := C_DADOS_CAB.QTPROGENTAF;
      OUT_RECORD.IDSITUCOLETA  := V_E_IDSITUCOLETA;
      OUT_RECORD.IDSITUAND     := V_E_IDSITUAND;
      OUT_RECORD.QTPROGENTAF   := V_E_QTPROGENTAF;
      OUT_RECORD.REFORFIL      := V_E_REFORFIL;
      OUT_RECORD.IDAPRMARPRO   := V_E_IDAPRMARPRO;
      OUT_RECORD.CDQUALIF      := V_E_CDQUALIF;
      OUT_RECORD.QFOPRODFORN   := V_E_QFOPRODFORN;
      OUT_RECORD.PRODCOMP      := V_E_PRODCOMP;
      OUT_RECORD.IDTIPOFORN    := V_E_IDTIPOFORN;
      OUT_RECORD.IDSITUCADA    := V_E_IDSITUCADA;
      OUT_RECORD.IDMARCAPADRAO := V_E_IDMARCAPADRAO;
      OUT_RECORD.PRODCMPFILI   := V_E_PRODCMPFILI;
      OUT_RECORD.STERRO        := V_STERRO;
      OUT_RECORD.IDSEMRELAC    := V_IDSEMRELAC;
      PIPE ROW (OUT_RECORD);
   END LOOP;
   RETURN;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VERIFICA_APURACAO_OL','6.02.XXX'); END;
/