/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INSUMETAPA                                               */
/* Tabela : INSUMETAPA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 26/01/2005 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPORETI' and
            type = 'TR'                  and
            u.uid = o.uid           	 and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPORETI
GO

CREATE TRIGGER DTULTATU_TIPORETI
ON TIPORETI
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPORETI', null, 'CDTIPORETI =' + CDTIPORETI, GETDATE()FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPORETI
      SET DTULTATUTIRE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPORETI.NMTIPORETI,0) = ISNULL(INSERTED.NMTIPORETI,0)) AND
            (ISNULL(TIPORETI.CDTIPORETI,0) = ISNULL(INSERTED.CDTIPORETI,0)) ;
   END;
END;
GO

